import asyncio
import graphene
from graphql import GraphQLError


class Query(graphene.ObjectType):
    hello = graphene.String(default_value="Hi!")


class Subscription(graphene.ObjectType):
    count_seconds = graphene.Int(up_to=graphene.Int())

    async def subscribe_count_seconds(root, info, up_to):
        if up_to > 30:
            raise GraphQLError('Count too high, must be <= 30')

        for i in range(up_to):
            print('TestSubs: ', i)
            yield i
            await asyncio.sleep(1)


schema = graphene.Schema(query=Query, subscription=Subscription)
